#include <bits/stdc++.h>

long long razlikaMedjuDanima(int n, int q, std::vector<long long>& a, std::vector<int>& b, long long& ostatak, int i) {
    long long x = 0;
    long long jedanDan = 0;

    x += a[i+1] - a[i];
    ostatak += b[i];
    if(x > ostatak) {
        jedanDan += ostatak;
        ostatak = 0;
    }
    else {
        ostatak -= x;
        jedanDan += x;
    }
    return jedanDan;
}

long long poslednjiDan(int n, int q, std::vector<long long>& a, std::vector<int>& b, std::vector<long long>& pitanje, long long& ostatak, int i, int k) {
    long long x = 0;
    long long jedanDan = 0;

    x += pitanje[k] - a[i];
    x++;
    ostatak += b[i];
    if(x > ostatak) {
        jedanDan += ostatak;
        ostatak = 0;
    }
    else {
        ostatak -= x;
        jedanDan += x;
    }
    return jedanDan;
}

long long poslednjeDonosenje(std::vector<long long>& a, long long p) {
    long long levi = 0, desni = a.size() - 1, pdon = -1;
     while (levi <= desni) {
        long long srednji = levi + (desni - levi) / 2;

        if (a[srednji] <= p) {
            pdon = srednji;
            levi = srednji + 1;
        } else {
            desni = srednji - 1;
        }
    }
    if(pdon == -1) return 0;
    return a[pdon];
}

int main() {

    int n, q;
    int i = 0;
    std::cin >> n >> q;
    std::vector<long long> a(n);
    std::vector<int> b(n);
    std::vector<long long> pitanje(q);

    for(int i = 0; i < n; i++) {
        std::cin >> a[i];
        std::cin >> b[i];
    }

    for(int i = 0; i < q; i++) {
        std::cin >> pitanje[i];
    }

    for(int k = 0; k < q; k++) {
        long long ostatak = 0;
        long long izmedjuDana = 0;
        long long pdon = poslednjeDonosenje(a, pitanje[k]);
        for(int i = 0; i < n && a[i] <= pdon; i++) {
            if(i != n-1 && a[i+1] <= pitanje[k]) {
                izmedjuDana += razlikaMedjuDanima(n, q, a, b, ostatak, i);
            }
            else {
                izmedjuDana += poslednjiDan(n, q, a, b, pitanje, ostatak, i, k);
            }
        }
        std::cout << izmedjuDana << std::endl;
    }

    return 0;
}